package helper

func TryPtrString(in *string, defval string) string {
	if in != nil {
		return *in
	}
	return defval
}

func TryPtrBool(in *bool, defval bool) bool {
	if in != nil {
		return *in
	}
	return defval
}

func TryPtrInt64(in *int64, defval int64) int64 {
	if in != nil {
		return *in
	}
	return defval
}

func TryPtrFloat32(in *float32, defval float32) float32 {
	if in != nil {
		return *in
	}
	return defval
}

func SetDefaultString(in string, defval string) string {
	if in != "" {
		return in
	}
	return defval
}

func IncludeString(val string, valset []string) bool {
	for _, item := range valset {
		if item == val {
			return true
		}
	}
	return false
}

func IncludeInt64(val int64, valset []int64) bool {
	for _, item := range valset {
		if item == val {
			return true
		}
	}
	return false
}
