package info

import (
	UserObject "gopher/ak/orm/user"
)

type UserInfo struct {
	Name   string `json:"name"`
	Email  string `json:"email"`
	Avatar string `json:"avatar"`
}

func NewUserInfo(user *UserObject.User) *UserInfo {
	avatar := "default_avatar_url"
	u := UserInfo{
		Name:   user.Name,
		Email:  user.Email,
		Avatar: avatar,
	}
	return &u
}
